<?php

use envoqon\web\Controller;
use envoqon\web\Html;
use envoqon\web\HttpException;
use expertinvoice\application\models\Option;



class OptionController extends Controller{
    
    public function filters() {
        return array(
            'accessControl'
        );
    }
    
    
    public function accessRules() {
        return array(
            array('allow', 
                'roles' => Option::getAppOption()->roles,
            ),
            array('deny', 
                'users' => array('*'),
            ),
        );
    }
    
    public function actionIndex() {
        $model = Option::getAppOption();
        if ($model === null) {
            throw new HttpException(404, 'The requested page does not exist.');
        }
        if (!empty($_POST)) {
            $model->setAttributes($_POST);
            if ($model->save()) {
                echo json_encode(array('code' => 200, 'id' => '', 'message' => 'Settings Saved'));
            }
            else {
                echo json_encode(array('code' => 500, 'message' => Html::errorSummary($model)));
            }
        }
        else {
            $this->pageTitle = 'Settings';
            $this->render('index', array('model' => $model));
        }
    }
    
    public function actionCreate() {
        $this->actionUpdate();
    }
    
    public function actionUpdate() {
        $model = Option::getAppOption();
        if ($model === null) {
            throw new HttpException(404, 'The requested page does not exist.');
        }
        if (!empty($_POST)) {
            $model->setAttributes($_POST);
            if ($model->save()) {
                echo json_encode(array('code' => 200, 'id' => '', 'message' => 'Settings Updated'));
            }
            else {
                echo json_encode(array('code' => 500, 'message' => Html::errorSummary($model)));
            }
        }
    }
}
