<?php

use envoqon\web\Controller;
use envoqon\web\Html;
use envoqon\web\HttpException;
use expertinvoice\application\models\Option;
use expertinvoice\application\models\Refund;

class RefundController extends Controller {

    public function filters() {
        return array(
            'accessControl'
        );
    }
    
    
    public function accessRules() {
        return array(
            array('allow', 
                'roles' => Option::getAppOption()->roles,
            ),
            array('deny', 
                'users' => array('*'),
            ),
        );
    }

    
    public function actionView($id) {
        $model = $this->loadModel($id);
        echo json_encode(array('code' => 200, 'data' => $model->toArray()));
    }

    
    public function actionCreate() {
        $model = new Refund();
        if (!empty($_POST)) {
            $model->setAttributes($_POST);
            if ($model->save()) {
                echo json_encode(array('code' => 200, 'id' => $model->id, 'message' => 'Refund saved'));
            }
            else {
                echo json_encode(array('code' => 500, 'message' => Html::errorSummary($model)));
            }
        }
    }

    
    public function actionUpdate($id) {
        $model = $this->loadModel($id);
        if (!empty($_POST)) {
            $model->setAttributes($_POST);
            if ($model->save()) {
                echo json_encode(array('code' => 200, 'id' => $model->id, 'message' => 'Refund updated'));
            }
            else {
                echo json_encode(array('code' => 500, 'message' => Html::errorSummary($model)));
            }
        }
    }

    
    public function actionDelete($id) {
        $this->loadModel($id)->delete();
        echo json_encode(array('id' => $id, 'message' => 'Selected record deleted'));
    }

    
    public function actionIndex() {
        $model = new Refund('search');
        $model->unsetAttributes();          if (isset($_GET['Refund'])) {
            $model->attributes = $_GET['Refund'];
        }
        $this->pageTitle = 'Refund';
        $this->render('index', array(
            'model' => $model,
        ));
    }

    
    public function loadModel($id) {
        $model = Refund::model()->findByPk($id);
        if ($model === null) {
            throw new HttpException(404, 'The requested page does not exist.');
        }
        return $model;
    }

}
