<?php

use envoqon\web\Controller;
use expertinvoice\application\models\Option;
use expertinvoice\application\utils\ReportHelper;

class ReportController extends Controller {
    
    public function filters() {
        return array(
            'accessControl'
        );
    }
    
    
    public function accessRules() {
        return array(
            array('allow', 
                'roles' => Option::getAppOption()->roles,
            ),
            array('deny', 
                'users' => array('*'),
            ),
        );
    }

    public function actionIndex() {
        $this->pageTitle = 'Reports';
        $this->render('index');
    }

    public function actionInvoice() {
        ReportHelper::invoice($_POST, 'Invoices Report');
    }

    public function actionQuotes() {
        ReportHelper::quotes($_POST, 'Quotes Report');
    }

    public function actionRefunds() {
        ReportHelper::refunds($_POST, 'Refund Sales Report');
    }

    public function actionItemSales() {
        ReportHelper::itemSales($_POST, 'Per Item Sales Report');
    }
    
    public function actionInventory() {
        ReportHelper::inventory($_POST, 'Inventory Report');
    }
    
    public function actionSalesTax() {
        ReportHelper::salesTax($_POST, 'Sales Tax Report (Based on full payments)');
    }

    public function actionCustomers() {
        ReportHelper::customerSales($_POST, 'Customers Report');
    }

    public function actionPayments() {
        ReportHelper::payments($_POST, 'Payments Report');
    }
    
    public function actionLowLevelStock() {
        ReportHelper::lowLevelStock($_POST, 'Low Stock Level Report');
    }
}
