<?php

use envoqon\db\DbMigration;

class m181231_124550_initial extends DbMigration {

        public function safeUp() {
        $this->createTable('{{expertinvoice_customer}}', array(
            'id' => 'pk',
            'name' => 'string NOT NULL',
            'contactPerson' => 'string DEFAULT NULL',
            'email' => 'varchar(128) DEFAULT NULL',
            'telephone1' => 'varchar(128) DEFAULT NULL',
            'telephone2' => 'varchar(128) DEFAULT NULL',
            'isActive' => 'integer DEFAULT 1',
            'shippingAddress' => 'text',
            'notes' => 'text',
            'isTaxExempt' => 'integer DEFAULT NULL',
            'categoryId' => 'integer NOT NULL',
            'createdDate' => 'datetime DEFAULT NULL',
            'updatedDate' => 'datetime DEFAULT NULL'
        ));

        $this->createTable('{{expertinvoice_id_generator}}', array(
            'id' => 'pk'
        ));
        $this->insert('{{expertinvoice_id_generator}}', array(
            'id' => 1000
        ));

        $this->createTable('{{expertinvoice_customer_category}}', array(
            'id' => 'pk',
            'name' => 'string NOT NULL',
            'description' => 'text',
        ));
        
        $this->insert('{{expertinvoice_customer_category}}', array(
            'name' => 'Uncategorized'
        ));

        $this->createTable('{{expertinvoice_invoice}}', array(
            'id' => 'pk',
            'title' => 'string NOT NULL',
            'receiptNumber' => 'integer DEFAULT 0',
            'quoteNumber' => 'integer DEFAULT 0',
            'customerId' => 'integer NOT NULL',
            'createdDate' => 'datetime DEFAULT NULL',
            'updatedDate' => 'datetime DEFAULT NULL',
            'termsDays' => 'integer DEFAULT NULL',
            'salesPerson' => 'integer DEFAULT NULL',
            'privateComment' => 'text',
            'comment' => 'text',
            'termsId' => 'integer DEFAULT NULL',
            'type' => 'integer NOT NULL',
            'status' => 'integer DEFAULT NULL',
            'amountDue' => 'decimal(12,2) DEFAULT NULL',
            'totalTax' => 'decimal(12,2) DEFAULT NULL',
            'hasRefund' => 'integer DEFAULT 0',
            'totalDiscount' => 'decimal(12,2) DEFAULT NULL',
            'discount' => 'decimal(12,2) DEFAULT NULL',
            'invoicedDate' => 'date DEFAULT NULL',
            'dueDate' => 'date DEFAULT NULL',
        ));
        
        $this->createIndex('invoice_invoice_customer', '{{expertinvoice_invoice}}', 'customerId', false);

        $this->createTable('{{expertinvoice_invoice_item}}', array(
            'id' => 'pk',
            'invoiceId' => 'integer NOT NULL',
            'quantity' => 'integer DEFAULT 0',
            'taxId' => 'integer DEFAULT 1',
            'tax' => 'decimal(12,2) DEFAULT NULL',
            'taxRate' => 'decimal(12,2) DEFAULT NULL',
            'discount' => 'decimal(12,2) DEFAULT NULL',
            'salePrice' => 'decimal(12,2) DEFAULT NULL',
            'productId' => 'integer NOT NULL',
        ));
        
        $this->createIndex('invoice_invoice_item', '{{expertinvoice_invoice_item}}', 'invoiceId', false);
        
        $this->createTable('{{expertinvoice_refund}}', array(
            'id' => 'pk',
            'invoiceId' => 'integer NOT NULL',
            'createdDate' => 'datetime DEFAULT NULL',
            'refundDate' => 'date DEFAULT NULL',
            'amount' => 'decimal(12,2) DEFAULT 0',
            'reference' => 'string DEFAULT NULL',
            'paymentMethod' => 'integer NOT NULL',
            'salesPerson' => 'integer DEFAULT NULL'
        ));

        $this->createTable('{{expertinvoice_payment}}', array(
            'id' => 'pk',
            'invoiceId' => 'integer NOT NULL',
            'datePaid' => 'date DEFAULT NULL',
            'dateCreated' => 'datetime DEFAULT NULL',
            'amount' => 'decimal(12,2) DEFAULT 0',
            'paymentMethod' => 'integer DEFAULT NULL',
            'transactionCode' => 'string NOT NULL'
        ));

        $this->createTable('{{expertinvoice_payment_method}}', array(
            'id' => 'pk',
            'name' => 'string NOT NULL',
            'description' => 'text',
            'shortcode'=>'string',
            'online'=> 'integer DEFAULT 0'
        ));

        $this->insert('{{expertinvoice_payment_method}}', array(
            'name' => 'Cash',
            'description' => 'Cash Payment'
        ));
        $this->insert('{{expertinvoice_payment_method}}', array(
            'name' => 'Cheque',
            'description' => 'Cheque Payment'
        ));


        $this->createTable('{{expertinvoice_product}}', array(
            'id' => 'pk',
            'name' => 'string NOT NULL',
            'sku' => 'varchar(128) DEFAULT NULL',
            'salePrice' => 'decimal(12,2) DEFAULT NULL',
            'taxId' => 'integer DEFAULT NULL',
            'isManaged' => 'integer DEFAULT NULL',
            'quantity' => 'integer NOT NULL',
            'warnQuantity' => 'integer NOT NULL',
            'description' => 'text',
            'createdDate' => 'datetime DEFAULT NULL',
            'updatedDate' => 'datetime DEFAULT NULL'
        ));

        $this->createTable('{{expertinvoice_tax}}', array(
            'id' => 'pk',
            'name' => 'string DEFAULT NULL',
            'rate' => 'decimal(12,2) DEFAULT NULL',
            'description' => 'text',
        ));
        
        $this->insert('{{expertinvoice_tax}}', array(
            'name' => 'No Tax',
            'rate' => 0
        ));
        $this->insert('{{expertinvoice_tax}}', array(
            'name' => 'Vat',
            'rate' => 0
        ));

        $this->createTable('{{expertinvoice_stock_transaction}}', array(
            'productId' => 'integer DEFAULT NULL',
            'direction' => 'integer DEFAULT NULL',
            'quantity' => 'integer DEFAULT NULL',
            'transactionDate' => 'datetime DEFAULT NULL',
            'userId' => 'integer DEFAULT NULL',
            'orderId' => 'integer',
            'cost' => 'decimal(12,2)',
            'note' => 'text',
        ));
    }

    public function safeDown() {
        $this->dropTable('{{expertinvoice_customer}}');
        $this->dropTable('{{expertinvoice_id_generator}}');
        $this->dropTable('{{expertinvoice_customer_category}}');
        $this->dropTable('{{expertinvoice_invoice}}');
        $this->dropTable('{{expertinvoice_invoice_item}}');
        $this->dropTable('{{expertinvoice_payment}}');
        $this->dropTable('{{expertinvoice_refund}}');
        $this->dropTable('{{expertinvoice_payment_method}}');
        $this->dropTable('{{expertinvoice_product}}');
        $this->dropTable('{{expertinvoice_tax}}');
        $this->dropTable('{{expertinvoice_stock_transaction}}');
    }

}
