<?php

namespace expertinvoice\application\models;

use envoqon\db\DbCriteria;
use envoqon\web\ActiveDataProvider;


class PaymentMethod extends \envoqon\db\ActiveRecord {
    
    private static $names;

    
    public function tableName() {
        return '{{expertinvoice_payment_method}}';
    }

    
    public function rules() {
                        return array(
            array('name', 'required'),
            array('name', 'length', 'max' => 255),
            array('description, link', 'safe'),
                                    array('id, name, description, options', 'safe', 'on' => 'search'),
        );
    }

    
    public function getPayments() {
        return Payment::model()->findAllByAttributes(array('paymentMethod' => $this->getPrimaryKey()));
    }

    public function getAttributeLabel($attribute) {
        return __('paymentMethod.' . $attribute, 'expert-invoice');
    }

    
    public function search() {
        $q = isset($_GET['q']) ? $_GET['q'] : null;
        $criteria = new DbCriteria;

        $criteria->compare('id', $q, false, 'OR');
        $criteria->compare('name', $q, true, 'OR');
        $criteria->compare('description', $q, true, 'OR');
        $criteria->compare('options', $q, true, 'OR');

        return new ActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

    
    public static function model($className = __CLASS__) {
        return parent::model($className);
    }
    
    public function listAll() {
        if (self::$names != null) {
            return self::$names;
        }
        $cat = $this->findAll(array('order' => 'name'));
        self::$names = array();
        foreach ($cat as $t) {
            self::$names[$t->id] = $t->name;
        }
        return self::$names;
    }

    public function getName($id) {
        $n = $this->listAll();
        return isset($n[$id]) ? $n[$id] : '';
    }

}
