<?php
namespace expertinvoice\application\models;

use envoqon\db\ActiveRecord;
use envoqon\utils\WpUtil;
use envoqon\utils\Date;
use upventory\application\models\User;

class StockTransaction extends ActiveRecord {

    const DIR_PLUS = 1;
    const DIR_MINUS = 2;

    
    public function tableName() {
        return '{{expertinvoice_stock_transaction}}';
    }

    
    public function rules() {
                        return array(
            array('productId, direction, quantity, userId', 'numerical', 'integerOnly' => true),
            array('transactionDate', 'safe'),
                                    array('productId, direction, quantity, transactionDate, userId, description', 'safe', 'on' => 'search'),
        );
    }


    public function getAttributeLabel($attribute) {
        return __('stockTransaction.' . $attribute, 'expert_invoice');
    }


    
    public static function model($className = __CLASS__) {
        return parent::model($className);
    }

    public function fields() {
        return array(
            'productId',
            'direction',
            'quantity',
            'transactionDate',
            'userId',
            'description',
        );
    }

    protected function beforeSave() {
        if(parent::beforeSave()){
            $this->direction = $this->quantity >= 0 ? StockTransaction::DIR_PLUS : StockTransaction::DIR_MINUS;
            $this->transactionDate = Date::format(time(), Date::PATTERN_ISO_8601_DATETIME);
            $this->userId = WpUtil::getUserId();
            $this->quantity = abs($this->quantity);
            return true;
        }
        return false;
    }
}
