<?php



namespace expertinvoice\application\models;


class Template extends \envoqon\db\CustomPost {

    protected function afterCustomPostCrated() {
        add_action('wp_loaded', array($this, 'loadTemplate'));
    }

    public function loadTemplate() {
        $args = array(
            'post_type' => 'expert_template',
            'post_status' => 'any',
            'posts_per_page' => 1,
        );
        $loop_posts = new \WP_Query($args);
        if (!$loop_posts->have_posts()) {
            wp_insert_post(array(
                'post_status' => 'publish',
                'post_author' => get_current_user_id(),
                'post_title' => 'Invoice',
                'post_name' => 'expert-invoice-template',
                'post_type' => 'expert_template',
                'post_content' => <<<EOD
                    Hello {{client}},
            Your invoice is attached to this email.
            You can pay your invoice by going to {{link}}
            Thank you.
EOD
            ));
            wp_insert_post(array(
                'post_status' => 'publish',
                'post_author' => get_current_user_id(),
                'post_title' => 'Payment Completed',
                'post_name' => 'expert-invoice-paid-template',
                'post_type' => 'expert_template',
                'post_content' => <<<EOD
                    Hello {{client}},
            Thank you for your payment. A payment invoice is attached to this email.
EOD
            ));
            wp_insert_post(array(
                'post_status' => 'publish',
                'post_author' => get_current_user_id(),
                'post_title' => 'Quote',
                'post_name' => 'expert-invoice-quote-template',
                'post_type' => 'expert_template',
                'post_content' => <<<EOD
                Hello {{client}},
            The quote you requested is attached to this email.
EOD
            ));
        }
    }

    protected function getPluralLabel() {
        return 'Email Templates';
    }

    protected function getSingularLabel() {
        return 'Email Template';
    }

    protected function getSlug() {
        return 'expert_template';
    }

    protected function savePost($update) {
        
    }

    protected function getSupports() {
        return array(
            'title',
            'editor',
        );
    }

    
    public static function model($className = __CLASS__) {
        return parent::model($className);
    }

}
