<?php

use envoqon\web\Html;
use expertinvoice\application\models\CustomerCategory;


?>
<script type="text/html" id="customer-template">
    <form role="form" class="form wide">

        <div>
            <?php echo Html::label(__('customer.name', 'expert-invoice'), false, array('required' => true)); ?>
            <div class="input-control text">
                <input type="text" class="form-control" data-bind="value:model.name">
            </div>
        </div>
        
        <div>
            <?php echo Html::label(__('customer.categoryId', 'expert-invoice'), false, array('required' => true)); ?>
            <div class="input-control select has-button">
                <?php
                echo Html::dropDownList('', '', CustomerCategory::model()->listAll(), array('style' => 'min-width:220px',
                    'data-bind' => 'value:model.categoryId',
                    'class' => 'form-control', 'id' => 'category_select'));
                ?>
                <button title="Create category" class="button" data-bind="click:model.createCategory "><span class="dashicons dashicons-plus"></span></button>
            </div>
        </div>

        <div>
            <?php echo Html::label(__('customer.contactPerson', 'expert-invoice'), false); ?>
            <div class="input-control text">
                <input type="text" class="form-control" data-bind="value:model.contactPerson">
            </div>
        </div>

        <div>
            <?php echo Html::label(__('customer.email', 'expert-invoice'), false); ?>
            <div class="input-control text">
                <input type="email" class="form-control" data-bind="value:model.email">
            </div>
        </div>

        <div>
            <?php echo Html::label(__('customer.telephone1', 'expert-invoice'), false); ?>
            <div class="input-control text">
                <input type="text" class="form-control" data-bind="value:model.telephone1">
            </div>
        </div>

        <div>
            <?php echo Html::label(__('customer.telephone2', 'expert-invoice'), false); ?>
            <div class="input-control text">
                <input type="text" class="form-control" data-bind="value:model.telephone2">
            </div>
        </div>

        <div>
            <?php echo Html::label(__('customer.shippingAddress', 'expert-invoice'), false); ?>
            <div class="input-control textarea">
                <textarea class="form-control" data-bind="value:model.shippingAddress"></textarea>
            </div>
        </div>

        <div class="align-center">
            <label class="no-padding-left input-control checkbox small-check">
                <input type="checkbox" class="form-control" data-bind="checked:model.isTaxExempt">
                <span class="caption"><?php echo __('customer.isTaxExempt', 'expert-invoice'); ?></span>
            </label>
            <label class="no-padding-left input-control checkbox small-check">
                <input type="checkbox" class="form-control" data-bind="checked:model.isActive">
                <span class="caption"><?php echo __('customer.isActive', 'expert-invoice'); ?></span>
            </label>
        </div> 
        <div>
            <?php echo Html::label(__('customer.notes', 'expert-invoice'), false); ?>
            <div class="input-control textarea">
                <textarea class="form-control" data-bind="value:model.notes"></textarea>
            </div>
        </div>

    </form>
</script>