<?php

use expertinvoice\application\models\Customer;
use expertinvoice\application\models\CustomerCategory;


?>
<div class="wrap" id="inner-content">
    <div class="toolbar">
        <h1 class="wp-heading-inline"><?php echo $this->pageTitle; ?></h1>
        <button type="button" class="page-title-action" data-bind="click:controller.add">Add Customer</button>
    </div>

    <?php
    $this->widget('envoqon\widgets\GridView', array(
        'id' => 'customer-grid',
        'dataProvider' => $model->search(),
        'columns' => array(
            array(
                'class' => 'envoqon\widgets\PrimaryColumn',
                'template' => '{update}{delete}',
                'header' => __('custome.name','expert-invoice'),
                'labelExpression' =>'$data["name"]',
                'click' => 'function(e){
                                e.preventDefault();
                                var id = jQuery(this).closest("tr").data("key");
                                global.controller.edit(id);
                            }',
                'buttons' => array(
                    'update' => array(
                        'class' => 'envoqon\widgets\UpdateActionLink',
                        'click' => 'function(e){
                            e.preventDefault();
                            var id = jQuery(this).closest("tr").data("key");
                            global.controller.edit(id);
                        }',
                    ),
                    'delete' => array(
                        'class' => 'envoqon\widgets\DeleteActionLink',
                        'afterDelete' => 'gridViewAfterDelete()',
                        'url' => 'ExpertInvoicePlugin::$app->controller->createAjaxUrl("customer/delete",array("id"=>$data["id"]))'
                    )
                ),
            ),
            'contactPerson',
            'email',
            'telephone1',
            array(
                'class' => 'envoqon\widgets\StateGridColumn',
                'header' => $model->getAttributeLabel('isTaxExempt'),
                'value' => '$data["isTaxExempt"]',
            ),
            array(
                'class' => 'envoqon\widgets\StateGridColumn',
                'header' => $model->getAttributeLabel('isActive'),
                'value' => '$data["isActive"]',
            ),
            array(
                'header' => $model->getAttributeLabel('categoryId'),
                'value' => function($data,$row){
                    return CustomerCategory::model()->getName($data['categoryId']);
                },
            ),
        ),
    ));
    ?>
</div>
<?php
$this->renderPartial('_form');
?>
<script type="text/javascript">
    jQuery(function () {
        global.controller = new CustomerController();
        ko.applyBindings({
            controller: global.controller
        }, document.getElementById('inner-content'));
    });
</script>