<?php

use envoqon\utils\WpUtil;
use envoqon\web\Html;
use expertinvoice\application\models\Option;

$option = Option::getAppOption();
?>
<?php
ExpertInvoicePlugin::$app->registerCssFile('bootstrap-grid-min', ExpertInvoicePlugin::$app->getPluginUrl() . '/css/vendors/bootstrap-grid.min.css');
ExpertInvoicePlugin::$app->registerCssFile('numpad-min', ExpertInvoicePlugin::$app->getPluginUrl() . '/css/vendors/numpad.min.css');
?>
<div class="wrap pos-dashboard" id="inner-content">
    <div class="toolbar">
        <h1 class="wp-heading-inline"><?php echo $this->pageTitle; ?></h1>
    </div>
    <div id="poststuff">
        <div id="post-body" class="metabox-holder columns-2">
            <div id="post-body-content">
                <div id="titlediv">
                    <div id="titlewrap">
                        <input type="text" name="post_title" size="30" data-bind="value: controller.activeBusket.invoice.title" placeholder="Enter title here" id="title" spellcheck="true" autocomplete="off">
                    </div>
                    <div class="inside">
                        <div id="edit-slug-box" class="hide-if-no-js">
                        </div>
                    </div>
                </div>
                <div class="meta-box-sortables">
                    <div class="postbox" style="min-height: 200px">
                        <h2><span>Invoice Items</span></h2>
                        <div class="inside">
                            <table class="table border bordered">
                                <thead>
                                    <tr>
                                        <th></th>
                                        <th class="main align-left">Item Name</th>
                                        <th class="align-center"><?php echo $option->unitPriceColumn; ?></th>
                                        <th class="align-center"><?php echo $option->quantityColumn; ?></th>
                                        <th class="align-center"><?php echo $option->lineTotalColumn; ?></th>
                                    </tr>
                                </thead>
                                <tbody data-bind="foreach: controller.activeBusket.items">
                                    <tr data-bind="click: global.controller.activeBusket.openPropertyPane">
                                        <td class="action">
                                            <span class="dashicons dashicons-no fg-red" data-bind="click: global.controller.activeBusket.removeItem"></span>
                                            <span class="dashicons dashicons-edit"></span>
                                        </td>
                                        <td>
                                            <p data-bind="text: name"></p>
                                        </td>
                                        <td class="align-center">
                                            <span data-bind="text: discountedSalesPrice"></span>
                                        </td>
                                        <td class="align-center">
                                            <input type="text" class="form-control" data-bind="value:quantity" onfocus="this.select();" onmouseup="return false;">
                                        </td>
                                        <td class="align-center">
                                            <p data-bind="text: getFormatedTotal"></p>
                                        </td>
                                    </tr>
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
                <div class="meta-box-sortables">
                    <div class="postbox">
                        <div class="inside">
                            <div id="tab-control" class="tabcontrol2" data-open-target="#_target_1">
                                <ul class="tabs">
                                    <li><a href="#_target_1"><?php echo __('invoice.comment', 'expert-invoice'); ?></a></li>
                                    <li><a href="#_target_2"><?php echo __('invoice.privateComment', 'expert-invoice'); ?></a></li>
                                </ul>
                                <div class="frames">
                                    <div id="_target_1" class="frame">
                                        <div class="form wide">
                                            <div class="input-control textarea block">
                                                <textarea class="form-control" data-bind="value:controller.activeBusket.invoice.comment"></textarea>
                                            </div>
                                        </div>
                                    </div>
                                    <div id="_target_2" class="frame">
                                        <div class="form wide">
                                            <div class="input-control textarea block">
                                                <textarea class="form-control" data-bind="value:controller.activeBusket.invoice.privateComment"></textarea>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div id="postbox-container-1" class="postbox-container">
                <div class="meta-box-sortables">
                    <div class="postbox">
                        <h2><span>Select items and quantity</span></h2>
                        <div class="inside">
                            <form class="form wide">
                                <div>
                                    <label class="">Quantity</label>
                                    <div class="input-control text" data-role="input">
                                        <input type="number" min="1" data-bind="value: controller.quantity" onfocus="this.select();" onmouseup="return false;">
                                    </div>
                                </div>
                                <div>
                                    <label class=""><?php echo __('product.name', 'expert-invoice'); ?></label>
                                    <div class="input-control text" data-role="input">
                                        <input type="text" id="item-search" placeholder="Type product code or name...">
                                        <button class="button"><span class="dashicons dashicons-search"></span></button>
                                    </div>
                                </div>
                            </form>
                        </div>
                    </div>
                    <div class="postbox">
                        <h2><span>Invoice Details</span></h2>
                        <div class="inside">
                            <div class="invoice-meta">
                                <form class="form wide">
                                    <div class="customer">
                                        <?php echo Html::label(__('invoice.customerId', 'expert-invoice'), false, array('required' => true)); ?>
                                        <div class="input-control text" data-role="input" data-bind="visible: !controller.activeBusket.invoice.customerId()">
                                            <input type="text" id="customer-search" placeholder="Type customer name to search...">
                                            <button class="button" data-bind="click: controller.createCustomer"><span class="dashicons dashicons-plus"></span></button>
                                        </div>
                                        <div data-bind="visible: controller.activeBusket.invoice.customerId()">
                                            <div class="user-details row">
                                                <div class="row no-padding">
                                                    <p class="col-sm-5 form">
                                                        <img class="" src="<?php echo ExpertInvoicePlugin::$app->getPluginUrl() ?>/images/icons/user.png"/>
                                                        <span class="inline-block" data-bind="text:controller.activeBusket.invoice.customerName"></span>    
                                                    </p>
                                                    <p class="form" style="padding-right: 0">
                                                        <button class="button small-button" data-bind="click: controller.removeCustomer"><span class="dashicons dashicons-no fg-red"></span>Detach</button>
                                                    </p>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div>
                                        <?php echo Html::label(__('invoice.receiptNumber', 'expert-invoice'), false, array('required' => true)); ?>
                                        <div class="input-control text">
                                            <input type="text" class="form-control" data-bind="value:controller.activeBusket.invoice.receiptNumber,disable: controller.activeBusket.invoice.id()">
                                        </div>
                                    </div>
                                    <div>
                                        <?php echo Html::label(__('invoice.invoicedDate', 'expert-invoice'), false, array('required' => true)); ?>
                                        <div class="input-control text">
                                            <input type="text" class="form-control" data-bind="value:controller.activeBusket.invoice.invoicedDate,datepicker:{}">
                                        </div>
                                    </div>
                                    <div>
                                        <?php echo Html::label(__('invoice.dueDate', 'expert-invoice'), false, array('required' => true)); ?>
                                        <div class="input-control text">
                                            <input type="text" class="form-control" data-bind="value:controller.activeBusket.invoice.dueDate,datepicker:{}">
                                        </div>
                                    </div>
                                </form>
                            </div> 
                        </div>
                    </div>                   
                    <div class="postbox">
                        <h2><span>Summary</span></h2>
                        <div class="inside">
                            <div class="summary sale-panel">
                                <div class="row" data-bind="visible: controller.activeBusket.invoice.discount() > 0">
                                    <div class="col-xs-6">
                                        <?php echo $option->discountColumn; ?>
                                    </div>
                                    <div class="col-xs-6">
                                        <span class="" data-bind="text:controller.activeBusket.getFormatedDiscount"></span>
                                    </div>
                                </div>
                                <div class="row align-right">
                                    <button class="button" data-bind="click: controller.activeBusket.adjust">Adjust Total</button>
                                </div>
                                <div class="row" data-bind="visible: controller.activeBusket.totalTax() > 0">
                                    <div class="col-xs-6">
                                        Tax
                                    </div>
                                    <div class="col-xs-6">
                                        <span data-bind="text:controller.activeBusket.getFormatedTax"></span>
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-xs-6">
                                        <?php echo $option->totalAmount; ?>
                                    </div>
                                    <div class="col-xs-6">
                                        <span class="amount fg-green" data-bind="text:controller.activeBusket.getFormatedAmountDue"></span>
                                    </div>
                                </div> 
                                <div class="align-center">
                                    <div class="dropdown-button">
                                        <button class="button button-primary" data-bind="click: global.controller.dropdown">Complete<span class="dashicons dashicons-arrow-down"></span></button>
                                        <ul class="split-content d-menu place-right" data-role="dropdown">
                                            <li><a href="#" data-bind="click:global.controller.record">Record</a></li>
                                            <li><a href="#" data-bind="click:global.controller.recordEmail">Record and Email</a></li>
                                            <li><a href="#" data-bind="click:global.controller.recordWithPayment">Record with Payment</a></li>
                                        </ul>
                                    </div>
                                </div>  
                            </div>
                        </div>
                    </div>
                    <div class="postbox item-edit">
                        <button type="button" class="handlediv" aria-expanded="true" data-bind="click: controller.activeBusket.closePropertyPane">
                            <span class="screen-reader-text">Toggle panel</span>
                            <span class="toggle-close" aria-hidden="true"></span>
                        </button>
                        <h2 class="hndle">Edit: <span data-bind="text: controller.activeBusket.selectedItem().name"></span></h2>
                        <div class="inside">
                            <form class="form wide">
                                <div class="margin20 qty-spinner"> 
                                    <label><?php echo $option->quantityColumn; ?> <span class="required">*</span></label>
                                    <div class="">
                                        <button title="Increase" class="button" data-bind="click:controller.activeBusket.selectedItem().minusQuantity "><span class="dashicons dashicons-minus"></span></button>
                                        <input type="text" class="form-control" disabled="disabled" data-bind="value:controller.activeBusket.selectedItem().quantity">
                                        <button title="Decrease" class="button" data-bind="click:controller.activeBusket.selectedItem().plusQuantity"><span class="dashicons dashicons-plus"></span></button>
                                    </div>
                                </div>
                                <div class="margin20"> 
                                    <label><?php echo $option->unitPriceColumn; ?><span class="required">*</span></label>
                                    <div class="input-control text">
                                        <input type="text" class="form-control align-right" disabled="disabled" data-bind="value:controller.activeBusket.selectedItem().salePrice">
                                    </div>
                                </div>
                                <div class="margin20"> 
                                    <p>Discount: <span class="bolder align-right inline-block fg-red" style="width:50%" data-bind="text: controller.activeBusket.selectedItem().getFormatedDiscount"></span></p>
                                    <p><?php echo $option->lineTotalColumn; ?>: <span class="bolder align-right inline-block fg-green" style="width:58%" data-bind="text: controller.activeBusket.selectedItem().getFormatedTotal"></span></p>
                                    <p class="align-right">
                                        <button class="button-primary" data-bind="click: controller.activeBusket.selectedItem().adjust">Adjust Price</button>
                                    </p>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
            <div class="row" id="receipt">
                <div class="row receipt-toolbar">
                    <div class="pull-right">
                        <button class="button" data-bind="click: controller.printReceipt">Print</button>
                        <button class="button" data-bind="click: controller.email">Email</button>
                        <button class="button" data-bind="click: controller.newSale">New Invoice</button>
                        <button class="button" data-bind="click: controller.editInvoice">Edit</button>
                    </div>
                </div>
                <div class="receipt-wrapper">
                    <iframe id="receipt-content" data-bind="attr: {src: controller.receiptLink}" width="100%" height="100%"></iframe>
                </div>
            </div>

        </div>
        <br class="clear">
    </div>
</div>
<?php
$this->renderPartial('/customer/_form');
$this->renderPartial('/invoice/_payment');
$data = array();
if (isset($model)) {
    $data['model'] = $model;
}
if (isset($items)) {
    $data['items'] = $items;
}
$this->renderPartial('/invoice/sale_js', $data);
?>
<script type="text/javascript">
    jQuery(function () {
        jQuery("#tab-control").tabs();
    });
</script>