<?php

use envoqon\utils\Date;
use envoqon\utils\WpUtil;
use envoqon\web\Html;
use expertinvoice\application\models\Option;
?>

<div id="tab-control" class="tabcontrol2" data-open-target="#_target_1">
    <ul class="tabs">
        <li><a href="#_target_1">Company</a></li>
        <li><a href="#_target_2">Tax</a></li>
        <li><a href="#_target_3">Invoice</a></li>
        <li><a href="#_target_4">Other</a></li>
        <li><a href="#_target_5">Permissions</a></li>
    </ul>
    <div class="frames">
        <div id="_target_1" class="frame">
            <form role="form" class="form wide">
                <div> 
                    <label><?php echo __('option.name', 'expert-invoice'); ?> <span class="required">*</span></label>
                    <div class="input-control text">
                        <input type="text" class="form-control" data-bind="value:model.name">
                    </div>
                </div>
                <div> 
                    <label><?php echo __('option.registeredNumber', 'expert-invoice'); ?></label>
                    <div class="input-control text">
                        <input type="text" class="form-control" data-bind="value:model.registeredNumber">
                    </div>
                </div>
<!--                <div> 
                    <label><?php echo __('option.email', 'expert-invoice'); ?><span class="required">*</span></label>
                    <div class="input-control text">
                        <input type="email" class="form-control" data-bind="value:model.email">
                    </div>
                </div>-->
                <div> 
                    <label><?php echo __('option.contactDetails', 'expert-invoice'); ?></label>
                    <div class="input-control textarea">
                        <textarea class="form-control" data-bind="value:model.contactDetails"></textarea>
                    </div>
                </div>
                <div>
                    <label><?php echo __('option.logo', 'expert-invoice'); ?></label>
                    <div class="input-control file" data-role="input">
                        <a class="button" data-bind="click:function(){ uploadWpImage(this,model.setIFileName)}">Upload</a>
                    </div>
                </div>    
                <p style="margin-left: 100px;">
                    <img data-bind="attr: {src:model.logo}"/>
                </p>
            </form>
        </div>
        <div id="_target_2" class="frame"> 
            <form role="form" class="form wide">
                <div>
                    <label class="no-padding-left input-control checkbox small-check">
                        <input type="checkbox" disabled data-bind="checked:model.taxIncluded">
                        <span class="check"></span>
                        <span class="caption"><?php echo __('option.taxIncluded', 'expert-invoice'); ?></span>
                    </label>
                </div>
            </form>
        </div>
        <div id="_target_3" class="frame"> 
            <form role="form" class="form wide">
                <div>
                    <label><?php echo __('option.invoiceStartNumber', 'expert-invoice'); ?> <span class="required">*</span></label>
                    <div class="input-control text">
                        <input type="email" class="form-control" data-bind="value:model.invoiceStartNumber">
                    </div>
                </div> 
                <p style="margin: 5px 0">Select the text you want to change, then enter the new text in the adjacent field</p>
                <div> 
                    <label>Receipt Text Titles:</label>
                    <div class="input-control select block-inline" style="min-width: 150px">
                        <?php
                        echo Html::dropDownList('', 'receiptTitle', Option::$receiptText, array('style' => '', 'data-bind' => 'value:model.prop',
                            'class' => 'form-control'));
                        ?>
                    </div>
                    <div class="input-control text block-inline" style="min-width: 250px">
                        <input type="text" class="form-control" data-bind="value:model.propValue">
                    </div>
                </div>
                <div style="margin-bottom: 10px;margin-top: 10px">
                    <label><?php echo __('option.footerComment', 'expert-invoice'); ?></label>
                    <div class="input-control textarea" style="width: 100%">
                        <textarea class="form-control" data-bind="value:model.footerComment"></textarea>
                    </div>
                </div>
                <div>
                    <div class="block-inline" style="width: 49%">
                        <label><?php echo __('option.footerCommentAlignment', 'expert-invoice'); ?></label>
                        <div class="input-control select" style="min-width: 150px">
                            <?php
                            echo Html::dropDownList('', '', Option::$alignments, array('style' => '', 'data-bind' => 'value:model.footerCommentAlignment',
                                'class' => 'form-control'));
                            ?>
                        </div>
                    </div>
                    <div class="block-inline" style="width: 50%">
                        <label><?php echo __('option.footerCommentFontSize', 'expert-invoice'); ?></label>
                        <div class="input-control select" style="min-width: 150px">
                            <?php
                            echo Html::dropDownList('', '', Option::$fontSizes, array('style' => '', 'data-bind' => 'value:model.footerCommentFontSize',
                                'class' => 'form-control'));
                            ?>
                        </div>
                    </div>
                </div>
            </form>
        </div>
        <div id="_target_4" class="frame"> 
            <form role="form" class="form wide">
                <div> 
                    <label><?php echo __('option.currency', 'expert-invoice'); ?> <span class="required">*</span></label>
                    <div class="input-control text">
                        <input type="text" class="form-control" data-bind="value:model.currency">
                    </div>
                </div>
                <div> 
                    <label><?php echo __('option.decimalSymbol', 'expert-invoice'); ?> <span class="required">*</span></label>
                    <div class="input-control text">
                        <input type="text" class="form-control" data-bind="value:model.decimalSymbol">
                    </div>
                </div>
                <div> 
                    <label><?php echo __('option.thousandsSymbol', 'expert-invoice'); ?> <span class="required">*</span></label>
                    <div class="input-control text">
                        <input type="text" class="form-control" data-bind="value:model.thousandsSymbol">
                    </div>
                </div>
                <div> 
                    <label><?php echo __('option.dateFormat', 'expert-invoice'); ?></label>
                    <div class="input-control select">
                        <?php
                        echo Html::dropDownList('', '', Date::datePatterns(), array('style' => 'min-width:220px', 'data-bind' => 'value:model.dateFormat',
                            'class' => 'form-control'));
                        ?>
                    </div>
                </div>
                <div>
                    <label><?php echo __('option.paymentPage', 'expert-invoice'); ?> <span class="required">*</span></label>
                    <div class="input-control select">
                        <select data-bind="value:model.paymentPage">
                            <?php
                            if ($pages = get_pages()) {
                                echo '<option value="">Select Page</option>';
                                foreach ($pages as $page) {
                                    echo '<option value="' . $page->ID . '">' . $page->post_title . '</option>';
                                }
                            }
                            ?>
                        </select>
                        <p class="hint">Add shortcode <code>[expert-invoice]</code> to that page</p>
                    </div>                    
                </div>
                <div>
                    <label><?php echo __('option.successPage', 'expert-invoice'); ?> <span class="required">*</span></label>
                    <div class="input-control select">
                        <select data-bind="value:model.successPage">
                            <?php
                            if ($pages = get_pages()) {
                                echo '<option value="">Select Page</option>';
                                foreach ($pages as $page) {
                                    echo '<option value="' . $page->ID . '">' . $page->post_title . '</option>';
                                }
                            }
                            ?>
                        </select>
                    </div>                    
                </div>
            </form>
        </div>
        <div id="_target_5" class="frame"> 
            <form role="form" class="form wide">
                <div>
                    <label><?php echo __('option.roles', 'expert-invoice'); ?> <span class="required">*</span></label>
                    <div class="input-control text">
                        <?php
                        foreach (WpUtil::$roles as $role) {
                            if($role == 'administrator'){
                                echo '<p><input type="checkbox" data-bind="checked: model.roles" disabled value="' . $role. '"/>' . ucfirst($role). '</p>';
                            }
                            else{
                                echo '<p><input type="checkbox" data-bind="checked: model.roles" value="' . $role. '"/>' . ucfirst($role). '</p>';
                            }
                        }
                        ?>
                    </div>
                </div>
            </form>
        </div>
    </div>
</div>