<?php

use expertinvoice\application\models\Product;
use expertinvoice\application\models\Tax;



?>
<div class="wrap" id="inner-content">
    <div class="toolbar">
        <h1 class="wp-heading-inline"><?php echo $this->pageTitle; ?></h1>
        <button type="button" class="page-title-action" data-bind="click:controller.add">Add Product</button>
    </div>

    <?php
    $this->widget('envoqon\widgets\GridView', array(
        'id' => 'product-grid',
        'dataProvider' => $model->search(),
        'columns' => array(
            array(
                'class' => 'envoqon\widgets\PrimaryColumn',
                'template' => '{update}{delete}',
                'header' => __('product.name','expert-invoice'),
                'labelExpression' =>'$data["name"]',
                'click' => 'function(e){
                                e.preventDefault();
                                var id = jQuery(this).closest("tr").data("key");
                                global.controller.edit(id);
                            }',
                'buttons' => array(
                    'update' => array(
                        'class' => 'envoqon\widgets\UpdateActionLink',
                        'click' => 'function(e){
                            e.preventDefault();
                            var id = jQuery(this).closest("tr").data("key");
                            global.controller.edit(id);
                        }',
                    ),
                    'delete' => array(
                        'class' => 'envoqon\widgets\DeleteActionLink',
                        'afterDelete' => 'gridViewAfterDelete()',
                        'url' => 'ExpertInvoicePlugin::$app->controller->createAjaxUrl("product/delete",array("id"=>$data["id"]))'
                    )
                ),
            ),
            'sku',
            array(
                'header' => __('product.quantity', 'expert-invoice'),
                'value' => function($data, $row) {
                    if ($data['isManaged'] == '1') {
                        return $data['quantity'];
                    }
                    else {
                        return '';
                    }
                },
            ),
            'salePrice',
            array(
                'header' => __('product.taxId', 'expert-invoice'),
                'value' => function($data, $row) {
                    return Tax::model()->getName($data['taxId']);
                },
            ),
        ),
    ));
    ?>
</div>
<?php
$this->renderPartial('_form');
?>
<script type="text/javascript">
    jQuery(function () {
        global.controller = new ProductController();
        ko.applyBindings({
            controller: global.controller
        }, document.getElementById('inner-content'));
    });
</script>