<?php

use envoqon\utils\Date;
use expertinvoice\application\models\Invoice;
use expertinvoice\application\models\Option;



?>
<div class="wrap" id="inner-content">
    <div class="toolbar">
        <h1 class="wp-heading-inline"><?php echo $this->pageTitle; ?></h1>
        <a href="<?php echo $this->createUrl('expert-invoice-quote', 'create'); ?>" class="page-title-action">Add Quote</a>
    </div>

    <?php
    $this->widget('envoqon\widgets\GridView', array(
        'id' => 'quote-grid',
        'dataProvider' => $model->quoteSearch(),
        'selectableRows' => 1,
        'columns' => array(
            array(
                'class' => 'envoqon\widgets\PrimaryColumn',
                'template' => '{update}{duplicate}{invoice}{view}{print}{email}{delete}',                      
                'class' => 'envoqon\widgets\PrimaryColumn',
                'header' => __('quote.title', 'expert-invoice'),
                'labelExpression' => '$data["title"]',
                'urlExpression'=>function($data){
                    return ExpertInvoicePlugin::$app->controller->createUrl("expert-invoice-invoice", "update", array("id" => $data["id"]));
                },
                'buttons' => array(
                    'invoice' => array(
                        'label' => 'Create Invoice',
                        'url' => 'ExpertInvoicePlugin::$app->controller->createUrl("expert-invoice-invoice","fromQuote",array("id"=>$data["id"]))'
                    ),
                    'email' => array(
                        'label' => 'Email',
                        'click' => 'function(e){
                            e.preventDefault();
                            var id = jQuery(this).closest("tr").data("key");
                            global.controller.email(id);
                    }',
                    ),
                    'print' => array(
                        'label' => 'Print',
                        'click' => 'function(e){
                            e.preventDefault();
                            var id = jQuery(this).closest("tr").data("key");
                            global.controller.printWindow("admin-ajax.php?action=' . ExpertInvoicePlugin::$app->getAjaxAction() . '&r=quote/print&id="+id);
                    }',
                    ),
                    'duplicate' => array(
                        'label'=>'Duplicate',
                        'url' => 'ExpertInvoicePlugin::$app->controller->createUrl("expert-invoice-quote","duplicate",array("id"=>$data["id"]))'
                    ),
                    'delete' => array(
                        'class' => 'envoqon\widgets\DeleteActionLink',
                        'afterDelete' => 'gridViewAfterDelete()',
                        'url' => 'ExpertInvoicePlugin::$app->controller->createAjaxUrl("quote/delete",array("id"=>$data["id"]))'
                    ),
                    'update' => array(
                        'class' => 'envoqon\widgets\UpdateActionLink',
                        'visible' => '$data->getStatus() == ' . Invoice::STATUS_UNPAID,
                        'url' => 'ExpertInvoicePlugin::$app->controller->createUrl("expert-invoice-quote","update",array("id"=>$data["id"]))'
                    ),
                    'view' => array(
                        'label' => 'View',
                        'url' => '$data->getViewUrl()',
                        'options'=>array(
                            'target'=>'_blank'
                        )
                    ),
                ),
            ),
            array(
                'header' => __('invoice.quoteNumber', 'expert-invoice'),
                'value' => function($data, $row) {
                    return $data['quoteNumber'];
                },
            ),
            array(
                'header' => __('invoice.customerId', 'expert-invoice'),
                'value' => function($data, $row) {
                    return $data['customer'];
                },
            ),
            array(
                'header' => __('quote.invoicedDate', 'expert-invoice'),
                'value' => function($data, $row) {
                    return Date::formatDateTime($data['invoicedDate'], Option::getAppOption()->dateFormat);
                },
            ),
            array(
                'header' => __('invoice.amountDue', 'expert-invoice'),
                'filter' => false,
                'value' => function($data, $row) {
                    return Option::getAppOption()->formatMoney($data['amountDue']);
                },
            ),
        ),
    ));
    ?>
</div>
<script type="text/javascript">
    jQuery(function () {
        global.controller = new InvoiceController();
        ko.applyBindings({
            controller: global.controller
        }, document.getElementById('inner-content'));
    });
</script>