<?php

use envoqon\utils\Date;
use expertinvoice\application\models\Option;
use expertinvoice\application\models\PaymentMethod;
use expertinvoice\application\models\Refund;



?>
<div class="wrap" id="inner-content">
    <div class="toolbar">
        <h1 class="wp-heading-inline"><?php echo $this->pageTitle; ?></h1>
        <button type="button" data-bind="click:controller.add" class="page-title-action">Add Refund</button>
    </div>

    <?php
    $this->widget('envoqon\widgets\GridView', array(
        'id' => 'refund-grid',
        'dataProvider' => $model->search(),
                'columns' => array(
            array(
                'class' => 'envoqon\widgets\PrimaryColumn',
                'template' => '{update}{delete}',
                'header' => __('payment.invoiceId', 'expert-invoice'),
                'labelExpression' =>'$data["invoice"]',
                'click' => 'function(e){
                                e.preventDefault();
                                var id = jQuery(this).closest("tr").data("key");
                                global.controller.edit(id);
                            }',
                'buttons' => array(
                    'update' => array(
                        'class' => 'envoqon\widgets\UpdateActionLink',
                        'click' => 'function(e){
                            e.preventDefault();
                            var id = jQuery(this).closest("tr").data("key");
                            global.controller.edit(id);
                        }',
                    ),
                    'delete' => array(
                        'class' => 'envoqon\widgets\DeleteActionLink',
                        'afterDelete' => 'gridViewAfterDelete()',
                        'url' => 'envoqon\App::instance()->controller->createAjaxUrl("refund/delete",array("id"=>$data["id"]))'
                    )
                ),
            ),
            array(
                'header' => __('refund.customer', 'expert-invoice'),
                'filter' => false,
                'value' => function($data, $row) {
                    return $data['customer'];
                },
            ),
            array(
                'header' => __('refund.amount', 'expert-invoice'),
                'filter' => false,
                'value' => function($data, $row) {
                    return Option::getAppOption()->formatMoney($data['amount']);
                },
            ),
            array(
                'header' => __('refund.reference', 'expert-invoice'),
                'filter' => false,
                'value' => function($data, $row) {
                    return $data['reference'];
                },
            ),
            array(
                'header' => __('refund.paymentMethod', 'expert-invoice'),
                'filter' => false,
                'value' => function($data, $row) {
                    return PaymentMethod::model()->getName($data['paymentMethod']);
                },
            ),
            array(
                'header' => __('refund.refundDate', 'expert-invoice'),
                'value' => function($data, $row) {
                    return Date::formatDateTime($data['refundDate'], Option::getAppOption()->dateFormat);
                },
            ),
        ),
    ));
    ?>
</div>
<?php
$this->renderPartial('_form');
?>
<script type="text/javascript">
    jQuery(function () {
        global.controller = new RefundController();
        ko.applyBindings({
            controller: global.controller
        }, document.getElementById('inner-content'));
    });
</script>