<?php

use envoqon\web\Html;
use expertinvoice\application\models\Invoice;
use expertinvoice\application\utils\ReportHelper;
?>
<script type="text/html" id="invoices-report-template">
    <h4>Invoices Reports</h4>
    <form role="form">
        <div>
            <label><?php echo __('invoice.status', 'expert-invoice'); ?></label>
            <div class="input-control text">
                <?php
                echo Html::dropDownList('', '', array(
                    Invoice::STATUS_UNPAID => __('invoice.unpaid', 'expert-invoice'),
                    Invoice::STATUS_PARTIALLY_PAID => __('invoice.partialpaid', 'expert-invoice'),
                    Invoice::STATUS_PAID => __('invoice.paid', 'expert-invoice')
                        ), array('style' => 'min-width:220px',
                    'data-bind' => 'value:model.status', 'prompt' => 'All',
                    'class' => 'form-control'));
                ?>
            </div>
        </div>
        <div>
            <label>Start Date</label>
            <div class="input-control text">
                <input type="text" class="form-control" data-bind="value:model.start,datepicker:{yearRange: '-100:+0',dateFormat: 'yy-mm-dd'}">
            </div>
        </div>
        <div>
            <label>End Date</label>
            <div class="input-control text">
                <input type="text" class="form-control" data-bind="value:model.end,datepicker:{yearRange: '-100:+0',dateFormat: 'yy-mm-dd'}">
            </div>
        </div>
    </form>
    <div data-role="buttonGroup" data-group-type="one-state" class="buttonGroup">
        <button class="button" data-bind="click:function(){model.reportType(<?php echo ReportHelper::REPORT_DATA; ?>)}">Submit</button>
    </div>
</script>