<?php



namespace envoqon\db;

use envoqon\App;
use envoqon\db\DbConnection;
use Exception;



class DbTransaction extends \envoqon\base\Component
{
	private $_connection=null;
	private $_active;

	
	public function __construct(DbConnection $connection)
	{
		$this->_connection=$connection;
		$this->_active=true;
	}

	
	public function commit()
	{
		if($this->_active && $this->_connection->getActive())
		{
			App::trace('Committing transaction','system.db.DbTransaction');
			$this->_connection->getPdoInstance()->commit();
			$this->_active=false;
		}
		else
			throw new DbException(App::t('app','DbTransaction is inactive and cannot perform commit.'));
	}

	
	public function rollback()
	{
		if($this->_active && $this->_connection->getActive())
		{
			App::trace('Rolling back transaction','system.db.DbTransaction');
			$this->_connection->getPdoInstance()->rollBack();
			$this->_active=false;
		}
		else
			throw new DbException(App::t('app','DbTransaction is inactive and cannot perform roll back operations.'));
	}

	
	public function getConnection()
	{
		return $this->_connection;
	}

	
	public function getActive()
	{
		return $this->_active;
	}

	
	protected function setActive($value)
	{
		$this->_active=$value;
	}
}

