<?php



namespace envoqon\utils;


class WpUtil {

    public static $roles = array('administrator', 'editor', 'author', 'contributor', 'subscriber');

    
    public static function currentUser() {
        return wp_get_current_user();
    }

    
    public static function isUserLoggedIn() {
        return is_user_logged_in();
    }

    
    public static function addRole($role, $display_name, $capabilities = array()) {
        add_role($role, $display_name, $capabilities);
    }

    public static function getUserId() {
        return get_current_user_id();
    }

    public static function listUsers($roles = ['author', 'administrator', 'editor', 'contributor']) {
        $wpusers = get_users(array('role__in' => $roles, 'fields' => array('display_name', 'ID')));
        $users = array();
        foreach ($wpusers as $user) {
            $users[$user->ID] = $user->display_name;
        }
        return $users;
    }

    public static function getTableName($table) {
        global $wpdb;
        return $wpdb->prefix . $table;
    }
    
    public static function getBlogName(){
        return get_bloginfo();
    }
    
    public static function getBlogEmail(){
        return get_bloginfo('admin_email');
    }

}
