<?php



namespace envoqon\validators;

use envoqon\App;


class RequiredValidator extends \envoqon\validators\Validator {

    
    public $requiredValue;

    
    public $strict = false;

    
    public $trim = true;

    
    public $condition;

    protected function validateAttribute($object, $attribute) {
        if ($this->condition != null && is_callable($this->condition)) {
            $callback = $this->condition;
            if (!$callback($object)) {
                return;
            }
        }
        $value = $object->$attribute;
        if ($this->requiredValue !== null) {
            if (!$this->strict && $value != $this->requiredValue || $this->strict && $value !== $this->requiredValue) {
                $message = $this->message !== null ? $this->message : App::t('app', '{attribute} must be {value}.', array('{value}' => $this->requiredValue));
                $this->addError($object, $attribute, $message);
            }
        }
        elseif ($this->isEmpty($value, $this->trim)) {
            $message = $this->message !== null ? $this->message : App::t('app', '{attribute} cannot be blank.');
            $this->addError($object, $attribute, $message);
        }
    }

    
    public function clientValidateAttribute($object, $attribute) {
        if ($this->condition != null && is_callable($this->condition)) {
            $callback = $this->condition;
            if (!$callback($object)) {
                return;
            }
        }
        $message = $this->message;
        if ($this->requiredValue !== null) {
            if ($message === null)
                $message = App::t('app', '{attribute} must be {value}.');
            $message = strtr($message, array(
                '{value}' => $this->requiredValue,
                '{attribute}' => $object->getAttributeLabel($attribute),
            ));
            return "
if(value!=" . json_encode($this->requiredValue) . ") {
	messages.push(" . json_encode($message) . ");
}
";
        }
        else {
            if ($message === null)
                $message = App::t('app', '{attribute} cannot be blank.');
            $message = strtr($message, array(
                '{attribute}' => $object->getAttributeLabel($attribute),
            ));
            if ($this->trim)
                $emptyCondition = "jQuery.trim(value)==''";
            else
                $emptyCondition = "value==''";
            return "
if({$emptyCondition}) {
	messages.push(" . json_encode($message) . ");
}
";
        }
    }

}
