<?php

namespace envoqon\web;

use envoqon\App;
use envoqon\db\QueryBuilder;




class QueryBuilderDataProvider extends \envoqon\web\ActiveDataProvider {

    
    public function getCriteria() {
        if ($this->_criteria === null)
            $this->_criteria = QueryBuilder::get();
    }

    
    public function setCriteria($value) {
        $this->_criteria = $value;
    }

    
    public function getCountCriteria() {
        if ($this->_countCriteria === null)
            return $this->getCriteria();
        return $this->_countCriteria;
    }

    
    public function setCountCriteria($value) {
        $this->_countCriteria = $value;
    }

    
    protected function fetchKeys() {
        $keys = array();
        $key = $this->keyAttribute === null ? 'id' : $this->keyAttribute;
        foreach ($this->getData() as $i => $data) {
            $keys[$i] = $data[$key];
        }
        return $keys;
    }

    
    protected function fetchData() {
        if (($pagination = $this->getPagination()) !== false) {
            if (!$pagination->getItemCount()) {
                $pagination->setItemCount($this->getTotalItemCount());
            }
            $this->_criteria->limit($pagination->getLimit());
            $this->_criteria->offset($pagination->getOffset());
        }
        if (($sort = $this->getSort()) !== false) {
            $order = $sort->getOrderBy();
            if (!empty($order)) {
                $this->_criteria->order($order);
            }
        }
        return $this->_criteria->queryAll();
    }

    
    protected function calculateTotalItemCount() {
        if ($this->_countCriteria) {
            return $this->_countCriteria->queryScalar();
        }
        $criteria = $this->_criteria->copy();
        if (!$criteria->rawSql) {            $criteria->select('COUNT(*)', false);
            return $criteria->queryScalar();
        }
        else {
            $db = App::getDb();
            $db->active = true;
            $pattern = '/(?is)select(.*?)from/';             $replacement = 'SELECT COUNT(*) FROM';
            $sql = preg_replace($pattern, $replacement, $criteria->getQueryString(), 1);
                                                $command = $db->createCommand($sql);
            $command->bindValues($criteria->params);
            return $command->queryScalar();
        }
    }

    
    public function getQueryBuilder() {
        return $this->_criteria;
    }

}
