<?php



namespace envoqon\web\filter;


class AccessRule extends \envoqon\base\Component {

    
    public $allow;

    
    public $actions;

    
    public $controllers;

    
    public $users;

    
    public $roles;

    
    public $verbs;

    
    public $expression;

    
    public $message;

    
    public $deniedCallback;

    
    public function isUserAllowed($user, $controller, $verb) {
        if ($this->isActionMatched($controller) && $this->isUserMatched($user) && $this->isRoleMatched($user) && $this->isVerbMatched($verb) && $this->isControllerMatched($controller) && $this->isExpressionMatched($user))
            return $this->allow ? 1 : -1;
        else
            return 0;
    }

    
    protected function isActionMatched($controller) {
        return empty($this->actions) || in_array(strtolower($controller->getActionId()), $this->actions);
    }

    
    protected function isControllerMatched($controller) {
        return empty($this->controllers) || in_array(strtolower($controller->getId()), $this->controllers);
    }

    
    protected function isUserMatched($user) {
        if (empty($this->users))
            return true;
        foreach ($this->users as $u) {
            if ($u === '*') {
                return true;
            }
            elseif (!strcasecmp($u, $user->getName())) {
                return true;
            }
        }
        return false;
    }

    
    protected function isRoleMatched($user) {
        if (empty($this->roles)) {
            return true;
        }
        foreach ($this->roles as $role) {
            if ($user->checkAccess($role)) {
                return true;
            }
        }
        return false;
    }

    
    protected function isVerbMatched($verb) {
        return empty($this->verbs) || in_array(strtolower($verb), $this->verbs);
    }

    
    protected function isExpressionMatched($user) {
        if ($this->expression === null)
            return true;
        else
            return $this->evaluateExpression($this->expression, array('user' => $user));
    }

}
