<?php



namespace envoqon\web\filter;

use envoqon\App;
use envoqon\web\Controller;
use \Exception;


class InlineFilter extends Filter {

    
    public $name;

    
    public static function create($controller, $filterName) {
        if (method_exists($controller, 'filter' . $filterName)) {
            $filter = new InlineFilter;
            $filter->name = $filterName;
            return $filter;
        }
        else
            throw new \Exception(App::t('app', 'Filter "{filter}" is invalid. Controller "{class}" does not have the filter method "filter{filter}".', array('{filter}' => $filterName, '{class}' => get_class($controller))));
    }

    
    public function filter($filterChain) {
        $method = 'filter' . $this->name;
        $filterChain->controller->$method($filterChain);
    }

}
