<?php



namespace envoqon\widgets;

use envoqon\web\Html;
use envoqon\web\ActiveDataProvider;
use envoqon\App;

class DataColumn extends \envoqon\widgets\GridColumn {

    
    public $name;

    
    public $value;

    
    public $type = 'text';

    
    public $sortable = true;

    
    public $filter;

    
    public function init() {
        parent::init();
        if ($this->name === null)
            $this->sortable = false;
        if ($this->name === null && $this->value === null)
            throw new \Exception(App::t('zii', 'Either "name" or "value" must be specified for DataColumn.'));
    }

    
    public function getFilterCellContent() {
        if (is_string($this->filter)) {
            return $this->filter;
        }
        return parent::getFilterCellContent();
    }

    
    public function getHeaderCellContent() {
        if ($this->grid->enableSorting && $this->sortable && $this->name !== null) {
            return $this->grid->dataProvider->getSort()->link($this->name, $this->header, array('class' => 'sort-link'));
        }
        elseif ($this->name !== null && $this->header === null) {
            if ($this->grid->dataProvider instanceof ActiveDataProvider)
                return Html::encode($this->grid->dataProvider->model->getAttributeLabel($this->name));
            else
                return Html::encode($this->name);
        }
        else
            return parent::getHeaderCellContent();
    }

    
    public function getDataCellContent($row) {
        $data = $this->grid->dataProvider->data[$row];
        if ($this->value !== null)
            $value = $this->evaluateExpression($this->value, array('data' => $data, 'row' => $row));
        elseif ($this->name !== null)
            $value = Html::value($data, $this->name);
        return $value === null ? $this->grid->nullDisplay : $this->grid->getFormatter()->format($value, $this->type);
    }

}
