<?php



namespace envoqon\widgets;

use envoqon\App;
use envoqon\web\Html;
use envoqon\web\JavaScript;


class DatePicker extends \envoqon\widgets\InputWidget {

    
    public $options = array();

    
    public $htmlOptions = array();

    
    public $defaultOptions;

    
    public $flat = false;

    
    public function run() {
        list($name, $id) = $this->resolveNameID();

        if (isset($this->htmlOptions['id']))
            $id = $this->htmlOptions['id'];
        else
            $this->htmlOptions['id'] = $id;
        if (isset($this->htmlOptions['name']))
            $name = $this->htmlOptions['name'];

        if ($this->flat === false) {
            if ($this->hasModel())
                echo Html::activeTextField($this->model, $this->attribute, $this->htmlOptions);
            else
                echo Html::textField($name, $this->value, $this->htmlOptions);
        }
        else {
            if ($this->hasModel()) {
                echo Html::activeHiddenField($this->model, $this->attribute, $this->htmlOptions);
                $attribute = $this->attribute;
                $this->options['defaultDate'] = $this->model->$attribute;
            }
            else {
                echo Html::hiddenField($name, $this->value, $this->htmlOptions);
                $this->options['defaultDate'] = $this->value;
            }

            $this->options['altField'] = '#' . $id;

            $id = $this->htmlOptions['id'] = $id . '_container';
            $this->htmlOptions['name'] = $name . '_container';

            echo Html::tag('div', $this->htmlOptions, '');
        }

        $options = JavaScript::encode($this->options);
        $js = "jQuery('#{$id}').datepicker($options);";


        $cs = App::instance();

        if (isset($this->defaultOptions)) {
            $cs->registerScript(__CLASS__, $this->defaultOptions !== null ? 'jQuery.datepicker.setDefaults(' . JavaScript::encode($this->defaultOptions) . ');' : '');
        }
        $cs->registerScript(__CLASS__ . '#' . $id, $js);
    }

}
