<?php



namespace envoqon\widgets;

use envoqon\App;
use envoqon\web\JavaScript;


class DeleteActionLink extends ActionLink {

    
    public $deleteConfirmation;

    
    public $afterDelete;
    
    public $options = array('class' => 'delete','style'=>'color:#a00');

    public function init() {
        if ($this->label === null) {
            $this->label = App::t('zii', 'Trash');
        }
        if ($this->deleteConfirmation === null) {
            $this->deleteConfirmation = App::t('zii', 'Are you sure you want to delete this item?');
        }
        if (is_string($this->deleteConfirmation))
            $confirmation = "if(!confirm(" . JavaScript::encode($this->deleteConfirmation) . ")) return false;";
        else
            $confirmation = '';

        $csrf = '';

        if ($this->afterDelete === null) {
            $this->afterDelete = 'function(){}';
        }
        if (!$this->click) {
            $this->click = <<<EOD
function() {
	$confirmation
	var th = this,
		afterDelete = $this->afterDelete;
	jQuery('#{$this->grid->id}').yiiGridView('update', {
		type: 'POST',
		url: jQuery(this).attr('href'),$csrf
		success: function(data) {
			jQuery('#{$this->grid->id}').yiiGridView('update');
			afterDelete(th, true, data);
		},
		error: function(XHR) {
			return afterDelete(th, false, XHR);
		}
	});
	return false;
}
EOD;
        }
    }

}
