<?php
namespace envoqon\widgets;

use envoqon\web\ActiveDataProvider;
use envoqon\web\Html;


class StateGridColumn extends \envoqon\widgets\GridColumn {


    
    public $onImageUrl = '<span class="dashicons dashicons-yes" style="color:green"></span>';

    
    public $offImageUrl = '<span class="dashicons dashicons-no" style="color:red"></span>';

    
    public $name;

    
    public $value;

    
    public $sortable = true;

    
    public $filter;

    
    protected function renderDataCellContent($row, $data) {
        if ($this->value !== null) {
            if (is_string($this->value)) {
                $value = $this->evaluateExpression($this->value, array('data' => $data, 'row' => $row));
            }
            else {
                $func = $this->value;
                $value = $func($data, $row);
            }
        }
        else {
            $value = Html::resolveValue($data, $this->name);
        }
        if ($value) {
            echo $this->onImageUrl;
        }
        else {
            echo $this->offImageUrl;
        }
    }


    
    public function getFilterCellContent() {
        if (is_string($this->filter)) {
            return $this->filter;
        }
        return parent::getFilterCellContent();
    }

    
    protected function renderHeaderCellContent() {
        if ($this->grid->enableSorting && $this->sortable && $this->name !== null)
            echo $this->grid->dataProvider->getSort()->link($this->name, $this->header);
        else if ($this->name !== null && $this->header === null) {
            if ($this->grid->dataProvider instanceof ActiveDataProvider)
                echo Html::encode($this->grid->dataProvider->model->getAttributeLabel($this->name));
            else
                echo Html::encode(ucfirst($this->name));
        }
        else
            parent::renderHeaderCellContent();
    }

}
