<?php

namespace envoqon\widgets;

use envoqon\App;
use envoqon\web\JavaScript;
use envoqon\web\Html;



class TabView extends \envoqon\widgets\Widget {

    
    public $tabs = array();

    
    public $tagName = 'div';

    
    public $headerTemplate = '<li><a href="{url}" >{title}</a></li>';

    
    public $contentTemplate = '<div id="{id}">{content}</div>';
    public $viewData = array();

    
    public $options = array();

    
    public $htmlOptions = array();

    
    public function run() {
        $this->htmlOptions['class'] = 'tabcontrol2';
        $disabled = array();
        $index = 0;
        foreach ($this->tabs as $key => $tab) {
            if (isset($tab['visible']) && $tab['visible'] == false) {
                $disabled[] = $index;
            }
            ++$index;
        }
        if (count($disabled)) {
            $this->options['disabled'] = $disabled;
        }
        if (empty($this->tabs)) {
            return;
        }
        $id = $this->getId();
        if (isset($this->htmlOptions['id'])) {
            $id = $this->htmlOptions['id'];
        }
        else {
            $this->htmlOptions['id'] = $id;
        }

        $tabsOut = "";
        $contentOut = "";
        $tabCount = 0;

        echo Html::openTag($this->tagName, $this->htmlOptions) . "\n";

        foreach ($this->tabs as $title => $content) {
            $tabId = (is_array($content) && isset($content['id'])) ? $content['id'] : $id . '_tab_' . $tabCount++;

            if (!is_array($content)) {
                $tabsOut .= strtr($this->headerTemplate, array('{title}' => $title, '{url}' => '#' . $tabId)) . "\n";
                $contentOut .= strtr($this->contentTemplate, array('{content}' => $content, '{id}' => $tabId)) . "\n";
            }
            elseif (isset($content['ajax'])) {
                $tabsOut .= strtr($this->headerTemplate, array('{title}' => $title, '{url}' => Html::normalizeUrl($content['ajax']), '{id}' => '#' . $tabId)) . "\n";
            }
            else if (isset($content['view'])) {
                if (isset($content['data'])) {
                    $data = $content['data'];
                }
                else {
                    $data = $this->viewData;
                }
                $content = App::instance()->getController()->renderPartial($content['view'], $data, true);
                $tabsOut .= strtr($this->headerTemplate, array('{title}' => $title, '{url}' => '#' . $tabId, '{id}' => '#' . $tabId)) . "\n";
                $contentOut .= strtr($this->contentTemplate, array('{content}' => $content, '{id}' => $tabId)) . "\n";
            }
            else {
                $tabsOut .= strtr($this->headerTemplate, array('{title}' => $title, '{url}' => '#' . $tabId, '{id}' => $tabId)) . "\n";
                if (isset($content['content'])) {
                    $contentOut .= strtr($this->contentTemplate, array('{content}' => $content['content'], '{id}' => $tabId)) . "\n";
                }
            }
        }
        echo "<ul class='tabs'>\n" . $tabsOut . "</ul>\n";
        echo $contentOut;
        echo Html::closeTag($this->tagName) . "\n";
        $options = JavaScript::encode($this->options);
        App::instance()->registerScript(__CLASS__ . '#' . $id, "jQuery('#{$id}').tabs($options);");
    }

}
